// Code generated by protoc-gen-go. DO NOT EDIT.
// source: envoy/config/filter/http/ext_authz/v2alpha/ext_authz.proto

package v2alpha

import (
	fmt "fmt"
	core "github.com/cilium/proxy/go/envoy/api/v2/core"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

// External Authorization filter calls out to an external service over either:
//
//  1. gRPC Authorization API defined by :ref:`CheckRequest
//     <envoy_api_msg_service.auth.v2alpha.CheckRequest>`.
//  2. Raw HTTP Authorization server by passing the request headers to the service.
//
// A failed check will cause this filter to close the HTTP request normally with 403 (Forbidden),
// unless a different status code has been indicated in the authorization response.
type ExtAuthz struct {
	// Types that are valid to be assigned to Services:
	//	*ExtAuthz_GrpcService
	//	*ExtAuthz_HttpService
	Services isExtAuthz_Services `protobuf_oneof:"services"`
	// The filter's behaviour in case the external authorization service does
	// not respond back. When set to true, Envoy will also allow traffic in cases when
	// an error occurs during the authorization process.
	// Defaults to false.
	FailureModeAllow     bool     `protobuf:"varint,2,opt,name=failure_mode_allow,json=failureModeAllow,proto3" json:"failure_mode_allow,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *ExtAuthz) Reset()         { *m = ExtAuthz{} }
func (m *ExtAuthz) String() string { return proto.CompactTextString(m) }
func (*ExtAuthz) ProtoMessage()    {}
func (*ExtAuthz) Descriptor() ([]byte, []int) {
	return fileDescriptor_971cd043e21bda4a, []int{0}
}

func (m *ExtAuthz) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_ExtAuthz.Unmarshal(m, b)
}
func (m *ExtAuthz) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_ExtAuthz.Marshal(b, m, deterministic)
}
func (m *ExtAuthz) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ExtAuthz.Merge(m, src)
}
func (m *ExtAuthz) XXX_Size() int {
	return xxx_messageInfo_ExtAuthz.Size(m)
}
func (m *ExtAuthz) XXX_DiscardUnknown() {
	xxx_messageInfo_ExtAuthz.DiscardUnknown(m)
}

var xxx_messageInfo_ExtAuthz proto.InternalMessageInfo

type isExtAuthz_Services interface {
	isExtAuthz_Services()
}

type ExtAuthz_GrpcService struct {
	GrpcService *core.GrpcService `protobuf:"bytes,1,opt,name=grpc_service,json=grpcService,proto3,oneof"`
}

type ExtAuthz_HttpService struct {
	HttpService *HttpService `protobuf:"bytes,3,opt,name=http_service,json=httpService,proto3,oneof"`
}

func (*ExtAuthz_GrpcService) isExtAuthz_Services() {}

func (*ExtAuthz_HttpService) isExtAuthz_Services() {}

func (m *ExtAuthz) GetServices() isExtAuthz_Services {
	if m != nil {
		return m.Services
	}
	return nil
}

func (m *ExtAuthz) GetGrpcService() *core.GrpcService {
	if x, ok := m.GetServices().(*ExtAuthz_GrpcService); ok {
		return x.GrpcService
	}
	return nil
}

func (m *ExtAuthz) GetHttpService() *HttpService {
	if x, ok := m.GetServices().(*ExtAuthz_HttpService); ok {
		return x.HttpService
	}
	return nil
}

func (m *ExtAuthz) GetFailureModeAllow() bool {
	if m != nil {
		return m.FailureModeAllow
	}
	return false
}

// XXX_OneofFuncs is for the internal use of the proto package.
func (*ExtAuthz) XXX_OneofFuncs() (func(msg proto.Message, b *proto.Buffer) error, func(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error), func(msg proto.Message) (n int), []interface{}) {
	return _ExtAuthz_OneofMarshaler, _ExtAuthz_OneofUnmarshaler, _ExtAuthz_OneofSizer, []interface{}{
		(*ExtAuthz_GrpcService)(nil),
		(*ExtAuthz_HttpService)(nil),
	}
}

func _ExtAuthz_OneofMarshaler(msg proto.Message, b *proto.Buffer) error {
	m := msg.(*ExtAuthz)
	// services
	switch x := m.Services.(type) {
	case *ExtAuthz_GrpcService:
		b.EncodeVarint(1<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.GrpcService); err != nil {
			return err
		}
	case *ExtAuthz_HttpService:
		b.EncodeVarint(3<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.HttpService); err != nil {
			return err
		}
	case nil:
	default:
		return fmt.Errorf("ExtAuthz.Services has unexpected type %T", x)
	}
	return nil
}

func _ExtAuthz_OneofUnmarshaler(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error) {
	m := msg.(*ExtAuthz)
	switch tag {
	case 1: // services.grpc_service
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(core.GrpcService)
		err := b.DecodeMessage(msg)
		m.Services = &ExtAuthz_GrpcService{msg}
		return true, err
	case 3: // services.http_service
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(HttpService)
		err := b.DecodeMessage(msg)
		m.Services = &ExtAuthz_HttpService{msg}
		return true, err
	default:
		return false, nil
	}
}

func _ExtAuthz_OneofSizer(msg proto.Message) (n int) {
	m := msg.(*ExtAuthz)
	// services
	switch x := m.Services.(type) {
	case *ExtAuthz_GrpcService:
		s := proto.Size(x.GrpcService)
		n += 1 // tag and wire
		n += proto.SizeVarint(uint64(s))
		n += s
	case *ExtAuthz_HttpService:
		s := proto.Size(x.HttpService)
		n += 1 // tag and wire
		n += proto.SizeVarint(uint64(s))
		n += s
	case nil:
	default:
		panic(fmt.Sprintf("proto: unexpected type %T in oneof", x))
	}
	return n
}

// External Authorization filter calls out to an upstream authorization server by passing the raw
// HTTP request headers to the server. This allows the authorization service to take a decision
// whether the request is authorized or not.
//
// A successful check allows the authorization service adding or overriding headers from the
// original request before dispatching it to the upstream. This is done by configuring which headers
// in the authorization response should be sent to the upstream. See *allowed_authorization_headers*
// below.
//
// A failed check will cause this filter to close the HTTP request with 403 (Forbidden),
// unless a different status code has been indicated by the authorization server via response
// headers.
//
// If an error happens during the checking process, two situations may occur depending on the
// filter's configuration:
//
//  1. When *failure_mode_allow* is true, traffic will be allowed in the presence of an error. This
//     includes any of the HTTP 5xx errors, or a communication failure between the filter and the
//     authorization server.
//  2. When *failure_mode_allow* is false, the filter will *always* return a *Forbidden response* to
//     the client. It will *not allow* traffic to the upstream in the presence of an error. This
//     includes any of the HTTP 5xx errors, or a communication failure between the filter and the
//     authorization server.
//
// Note that filter will produce stats on error. See *Statistics* at :ref:`configuration overview
// <config_http_filters_ext_authz>`.
type HttpService struct {
	// Sets the HTTP server URI which the authorization requests must be sent to.
	ServerUri *core.HttpUri `protobuf:"bytes,1,opt,name=server_uri,json=serverUri,proto3" json:"server_uri,omitempty"`
	// Sets an optional prefix to the value of authorization request header *Path*.
	PathPrefix string `protobuf:"bytes,2,opt,name=path_prefix,json=pathPrefix,proto3" json:"path_prefix,omitempty"`
	// Sets a list of headers that can be sent from the authorization server to the upstream service,
	// or to the downstream client when present in the authorization response. Note that a matched
	// request header will have its value overridden by the ones sent from the authorization server.
	AllowedAuthorizationHeaders []string `protobuf:"bytes,4,rep,name=allowed_authorization_headers,json=allowedAuthorizationHeaders,proto3" json:"allowed_authorization_headers,omitempty"`
	// Sets a list of headers that should be sent *from the filter* to the authorization server
	// when they are also present in the client request. Note that *Content-Length*, *Authority*,
	// *Method* and *Path* are always dispatched to the authorization server by default. The message
	// will not contain body data and the *Content-Length* will be set to zero.
	AllowedRequestHeaders []string `protobuf:"bytes,5,rep,name=allowed_request_headers,json=allowedRequestHeaders,proto3" json:"allowed_request_headers,omitempty"`
	// Sets a list of headers and their values that will be added to the request to external
	// authorization server. Note that these will override the headers coming from the downstream.
	AuthorizationHeadersToAdd []*core.HeaderValue `protobuf:"bytes,6,rep,name=authorization_headers_to_add,json=authorizationHeadersToAdd,proto3" json:"authorization_headers_to_add,omitempty"`
	XXX_NoUnkeyedLiteral      struct{}            `json:"-"`
	XXX_unrecognized          []byte              `json:"-"`
	XXX_sizecache             int32               `json:"-"`
}

func (m *HttpService) Reset()         { *m = HttpService{} }
func (m *HttpService) String() string { return proto.CompactTextString(m) }
func (*HttpService) ProtoMessage()    {}
func (*HttpService) Descriptor() ([]byte, []int) {
	return fileDescriptor_971cd043e21bda4a, []int{1}
}

func (m *HttpService) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HttpService.Unmarshal(m, b)
}
func (m *HttpService) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HttpService.Marshal(b, m, deterministic)
}
func (m *HttpService) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HttpService.Merge(m, src)
}
func (m *HttpService) XXX_Size() int {
	return xxx_messageInfo_HttpService.Size(m)
}
func (m *HttpService) XXX_DiscardUnknown() {
	xxx_messageInfo_HttpService.DiscardUnknown(m)
}

var xxx_messageInfo_HttpService proto.InternalMessageInfo

func (m *HttpService) GetServerUri() *core.HttpUri {
	if m != nil {
		return m.ServerUri
	}
	return nil
}

func (m *HttpService) GetPathPrefix() string {
	if m != nil {
		return m.PathPrefix
	}
	return ""
}

func (m *HttpService) GetAllowedAuthorizationHeaders() []string {
	if m != nil {
		return m.AllowedAuthorizationHeaders
	}
	return nil
}

func (m *HttpService) GetAllowedRequestHeaders() []string {
	if m != nil {
		return m.AllowedRequestHeaders
	}
	return nil
}

func (m *HttpService) GetAuthorizationHeadersToAdd() []*core.HeaderValue {
	if m != nil {
		return m.AuthorizationHeadersToAdd
	}
	return nil
}

func init() {
	proto.RegisterType((*ExtAuthz)(nil), "envoy.config.filter.http.ext_authz.v2alpha.ExtAuthz")
	proto.RegisterType((*HttpService)(nil), "envoy.config.filter.http.ext_authz.v2alpha.HttpService")
}

func init() {
	proto.RegisterFile("envoy/config/filter/http/ext_authz/v2alpha/ext_authz.proto", fileDescriptor_971cd043e21bda4a)
}

var fileDescriptor_971cd043e21bda4a = []byte{
	// 425 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x92, 0xd1, 0x8a, 0xd4, 0x30,
	0x14, 0x86, 0x9d, 0x9d, 0x71, 0x9d, 0xc9, 0xec, 0xc5, 0x12, 0x10, 0xc7, 0x71, 0xd5, 0xb2, 0x78,
	0x31, 0x88, 0x24, 0x50, 0x41, 0xd1, 0xbb, 0x8e, 0x88, 0x83, 0x20, 0x48, 0x75, 0xbd, 0x10, 0x21,
	0x64, 0x9b, 0xd3, 0x69, 0xa0, 0x4e, 0x62, 0x9a, 0xd6, 0x71, 0x9f, 0xd1, 0xf7, 0xf0, 0x35, 0x24,
	0x49, 0x6b, 0x0b, 0x3b, 0xc2, 0x5e, 0xe6, 0x9c, 0xff, 0xff, 0xfe, 0x73, 0x7a, 0x8a, 0x5e, 0xc3,
	0xae, 0x51, 0xbf, 0x68, 0xa6, 0x76, 0xb9, 0xdc, 0xd2, 0x5c, 0x96, 0x16, 0x0c, 0x2d, 0xac, 0xd5,
	0x14, 0xf6, 0x96, 0xf1, 0xda, 0x16, 0x57, 0xb4, 0x89, 0x79, 0xa9, 0x0b, 0xde, 0x57, 0x88, 0x36,
	0xca, 0x2a, 0xfc, 0xd4, 0x7b, 0x49, 0xf0, 0x92, 0xe0, 0x25, 0xce, 0x4b, 0x7a, 0x65, 0xeb, 0x5d,
	0x9e, 0x85, 0x1c, 0xae, 0x25, 0x6d, 0x62, 0x9a, 0x29, 0x03, 0xf4, 0x92, 0x57, 0x10, 0x48, 0xcb,
	0x27, 0xd7, 0xbb, 0x5b, 0xa3, 0x33, 0x56, 0x81, 0x69, 0x64, 0xd6, 0xa9, 0xa2, 0xeb, 0x2a, 0x97,
	0xc6, 0x6a, 0x23, 0x83, 0xe2, 0xfc, 0xcf, 0x08, 0x4d, 0xdf, 0xee, 0x6d, 0xe2, 0xa2, 0xf1, 0x1b,
	0x74, 0x32, 0x84, 0x2c, 0x46, 0xd1, 0x68, 0x35, 0x8f, 0x1f, 0x91, 0x30, 0x35, 0xd7, 0x92, 0x34,
	0x31, 0x71, 0x14, 0xf2, 0xce, 0xe8, 0xec, 0x53, 0x50, 0x6d, 0x6e, 0xa5, 0xf3, 0x6d, 0xff, 0xc4,
	0xdf, 0xd0, 0x89, 0xcf, 0xe8, 0x20, 0x63, 0x0f, 0x79, 0x49, 0x6e, 0xbe, 0x3a, 0xd9, 0x58, 0xab,
	0x07, 0xf4, 0xa2, 0x7f, 0xe2, 0x67, 0x08, 0xe7, 0x5c, 0x96, 0xb5, 0x01, 0xf6, 0x5d, 0x09, 0x60,
	0xbc, 0x2c, 0xd5, 0xcf, 0xc5, 0x51, 0x34, 0x5a, 0x4d, 0xd3, 0xd3, 0xb6, 0xf3, 0x41, 0x09, 0x48,
	0x5c, 0x7d, 0x8d, 0xd0, 0xb4, 0x1d, 0xa3, 0x3a, 0xff, 0x7d, 0x84, 0xe6, 0x03, 0x30, 0x7e, 0x85,
	0x90, 0xeb, 0x81, 0x71, 0x5f, 0xa3, 0x5d, 0x75, 0x79, 0x60, 0x55, 0xe7, 0xb9, 0x30, 0x32, 0x9d,
	0x05, 0xf5, 0x85, 0x91, 0xf8, 0x31, 0x9a, 0x6b, 0x6e, 0x0b, 0xa6, 0x0d, 0xe4, 0x72, 0xef, 0xd3,
	0x67, 0x29, 0x72, 0xa5, 0x8f, 0xbe, 0x82, 0xd7, 0xe8, 0xa1, 0x1f, 0x0c, 0x84, 0xdf, 0x4c, 0x19,
	0x79, 0xc5, 0xad, 0x54, 0x3b, 0x56, 0x00, 0x17, 0x60, 0xaa, 0xc5, 0x24, 0x1a, 0xaf, 0x66, 0xe9,
	0x83, 0x56, 0x94, 0x0c, 0x35, 0x9b, 0x20, 0xc1, 0x2f, 0xd0, 0xbd, 0x8e, 0x61, 0xe0, 0x47, 0x0d,
	0x95, 0xfd, 0xe7, 0xbe, 0xed, 0xdd, 0x77, 0xdb, 0x76, 0x1a, 0xba, 0x9d, 0x8f, 0xa1, 0xb3, 0x83,
	0x99, 0xcc, 0x2a, 0xc6, 0x85, 0x58, 0x1c, 0x47, 0xe3, 0xff, 0x1c, 0x35, 0x10, 0xbe, 0xf0, 0xb2,
	0x86, 0xf4, 0x3e, 0x3f, 0x30, 0xd3, 0x67, 0x95, 0x08, 0xf1, 0x7e, 0x32, 0x1d, 0x9f, 0x4e, 0xd6,
	0xb3, 0xaf, 0x77, 0xda, 0x73, 0x5d, 0x1e, 0xfb, 0x5f, 0xe9, 0xf9, 0xdf, 0x00, 0x00, 0x00, 0xff,
	0xff, 0xf1, 0x46, 0x78, 0x33, 0x1a, 0x03, 0x00, 0x00,
}
