// Code generated by protoc-gen-go. DO NOT EDIT.
// source: envoy/config/filter/network/tcp_proxy/v2/tcp_proxy.proto

package v2

import (
	fmt "fmt"
	core "github.com/cilium/proxy/go/envoy/api/v2/core"
	v2 "github.com/cilium/proxy/go/envoy/config/filter/accesslog/v2"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/golang/protobuf/proto"
	duration "github.com/golang/protobuf/ptypes/duration"
	wrappers "github.com/golang/protobuf/ptypes/wrappers"
	_ "github.com/lyft/protoc-gen-validate/validate"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type TcpProxy struct {
	// The prefix to use when emitting :ref:`statistics
	// <config_network_filters_tcp_proxy_stats>`.
	StatPrefix string `protobuf:"bytes,1,opt,name=stat_prefix,json=statPrefix,proto3" json:"stat_prefix,omitempty"`
	// Types that are valid to be assigned to ClusterSpecifier:
	//	*TcpProxy_Cluster
	//	*TcpProxy_WeightedClusters
	ClusterSpecifier isTcpProxy_ClusterSpecifier `protobuf_oneof:"cluster_specifier"`
	// Optional endpoint metadata match criteria. Only endpoints in the upstream
	// cluster with metadata matching that set in metadata_match will be
	// considered. The filter name should be specified as *envoy.lb*.
	MetadataMatch *core.Metadata `protobuf:"bytes,9,opt,name=metadata_match,json=metadataMatch,proto3" json:"metadata_match,omitempty"`
	// The idle timeout for connections managed by the TCP proxy filter. The idle timeout
	// is defined as the period in which there are no bytes sent or received on either
	// the upstream or downstream connection. If not set, connections will never be closed
	// by the TCP proxy due to being idle.
	IdleTimeout *duration.Duration `protobuf:"bytes,8,opt,name=idle_timeout,json=idleTimeout,proto3" json:"idle_timeout,omitempty"`
	// [#not-implemented-hide:] The idle timeout for connections managed by the TCP proxy
	// filter. The idle timeout is defined as the period in which there is no
	// active traffic. If not set, there is no idle timeout. When the idle timeout
	// is reached the connection will be closed. The distinction between
	// downstream_idle_timeout/upstream_idle_timeout provides a means to set
	// timeout based on the last byte sent on the downstream/upstream connection.
	DownstreamIdleTimeout *duration.Duration `protobuf:"bytes,3,opt,name=downstream_idle_timeout,json=downstreamIdleTimeout,proto3" json:"downstream_idle_timeout,omitempty"`
	// [#not-implemented-hide:]
	UpstreamIdleTimeout *duration.Duration `protobuf:"bytes,4,opt,name=upstream_idle_timeout,json=upstreamIdleTimeout,proto3" json:"upstream_idle_timeout,omitempty"`
	// Configuration for :ref:`access logs <arch_overview_access_logs>`
	// emitted by the this tcp_proxy.
	AccessLog []*v2.AccessLog `protobuf:"bytes,5,rep,name=access_log,json=accessLog,proto3" json:"access_log,omitempty"`
	// TCP Proxy filter configuration using deprecated V1 format. This is required for complex
	// routing until filter chain matching in the listener is implemented.
	//
	// .. attention::
	//
	//   Using this field will lead to `problems loading the configuration
	//   <https://github.com/envoyproxy/envoy/issues/2441>`_. If you want to configure the filter
	//   using v1 config structure, please make this field a boolean with value ``true`` and configure
	//   via the opaque ``value`` field like is suggested in :api:`envoy/config/filter/README.md`.
	DeprecatedV1 *TcpProxy_DeprecatedV1 `protobuf:"bytes,6,opt,name=deprecated_v1,json=deprecatedV1,proto3" json:"deprecated_v1,omitempty"` // Deprecated: Do not use.
	// The maximum number of unsuccessful connection attempts that will be made before
	// giving up. If the parameter is not specified, 1 connection attempt will be made.
	MaxConnectAttempts   *wrappers.UInt32Value `protobuf:"bytes,7,opt,name=max_connect_attempts,json=maxConnectAttempts,proto3" json:"max_connect_attempts,omitempty"`
	XXX_NoUnkeyedLiteral struct{}              `json:"-"`
	XXX_unrecognized     []byte                `json:"-"`
	XXX_sizecache        int32                 `json:"-"`
}

func (m *TcpProxy) Reset()         { *m = TcpProxy{} }
func (m *TcpProxy) String() string { return proto.CompactTextString(m) }
func (*TcpProxy) ProtoMessage()    {}
func (*TcpProxy) Descriptor() ([]byte, []int) {
	return fileDescriptor_1f6b35dbcbad27ba, []int{0}
}

func (m *TcpProxy) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TcpProxy.Unmarshal(m, b)
}
func (m *TcpProxy) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TcpProxy.Marshal(b, m, deterministic)
}
func (m *TcpProxy) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TcpProxy.Merge(m, src)
}
func (m *TcpProxy) XXX_Size() int {
	return xxx_messageInfo_TcpProxy.Size(m)
}
func (m *TcpProxy) XXX_DiscardUnknown() {
	xxx_messageInfo_TcpProxy.DiscardUnknown(m)
}

var xxx_messageInfo_TcpProxy proto.InternalMessageInfo

func (m *TcpProxy) GetStatPrefix() string {
	if m != nil {
		return m.StatPrefix
	}
	return ""
}

type isTcpProxy_ClusterSpecifier interface {
	isTcpProxy_ClusterSpecifier()
}

type TcpProxy_Cluster struct {
	Cluster string `protobuf:"bytes,2,opt,name=cluster,proto3,oneof"`
}

type TcpProxy_WeightedClusters struct {
	WeightedClusters *TcpProxy_WeightedCluster `protobuf:"bytes,10,opt,name=weighted_clusters,json=weightedClusters,proto3,oneof"`
}

func (*TcpProxy_Cluster) isTcpProxy_ClusterSpecifier() {}

func (*TcpProxy_WeightedClusters) isTcpProxy_ClusterSpecifier() {}

func (m *TcpProxy) GetClusterSpecifier() isTcpProxy_ClusterSpecifier {
	if m != nil {
		return m.ClusterSpecifier
	}
	return nil
}

func (m *TcpProxy) GetCluster() string {
	if x, ok := m.GetClusterSpecifier().(*TcpProxy_Cluster); ok {
		return x.Cluster
	}
	return ""
}

func (m *TcpProxy) GetWeightedClusters() *TcpProxy_WeightedCluster {
	if x, ok := m.GetClusterSpecifier().(*TcpProxy_WeightedClusters); ok {
		return x.WeightedClusters
	}
	return nil
}

func (m *TcpProxy) GetMetadataMatch() *core.Metadata {
	if m != nil {
		return m.MetadataMatch
	}
	return nil
}

func (m *TcpProxy) GetIdleTimeout() *duration.Duration {
	if m != nil {
		return m.IdleTimeout
	}
	return nil
}

func (m *TcpProxy) GetDownstreamIdleTimeout() *duration.Duration {
	if m != nil {
		return m.DownstreamIdleTimeout
	}
	return nil
}

func (m *TcpProxy) GetUpstreamIdleTimeout() *duration.Duration {
	if m != nil {
		return m.UpstreamIdleTimeout
	}
	return nil
}

func (m *TcpProxy) GetAccessLog() []*v2.AccessLog {
	if m != nil {
		return m.AccessLog
	}
	return nil
}

// Deprecated: Do not use.
func (m *TcpProxy) GetDeprecatedV1() *TcpProxy_DeprecatedV1 {
	if m != nil {
		return m.DeprecatedV1
	}
	return nil
}

func (m *TcpProxy) GetMaxConnectAttempts() *wrappers.UInt32Value {
	if m != nil {
		return m.MaxConnectAttempts
	}
	return nil
}

// XXX_OneofFuncs is for the internal use of the proto package.
func (*TcpProxy) XXX_OneofFuncs() (func(msg proto.Message, b *proto.Buffer) error, func(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error), func(msg proto.Message) (n int), []interface{}) {
	return _TcpProxy_OneofMarshaler, _TcpProxy_OneofUnmarshaler, _TcpProxy_OneofSizer, []interface{}{
		(*TcpProxy_Cluster)(nil),
		(*TcpProxy_WeightedClusters)(nil),
	}
}

func _TcpProxy_OneofMarshaler(msg proto.Message, b *proto.Buffer) error {
	m := msg.(*TcpProxy)
	// cluster_specifier
	switch x := m.ClusterSpecifier.(type) {
	case *TcpProxy_Cluster:
		b.EncodeVarint(2<<3 | proto.WireBytes)
		b.EncodeStringBytes(x.Cluster)
	case *TcpProxy_WeightedClusters:
		b.EncodeVarint(10<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.WeightedClusters); err != nil {
			return err
		}
	case nil:
	default:
		return fmt.Errorf("TcpProxy.ClusterSpecifier has unexpected type %T", x)
	}
	return nil
}

func _TcpProxy_OneofUnmarshaler(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error) {
	m := msg.(*TcpProxy)
	switch tag {
	case 2: // cluster_specifier.cluster
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		x, err := b.DecodeStringBytes()
		m.ClusterSpecifier = &TcpProxy_Cluster{x}
		return true, err
	case 10: // cluster_specifier.weighted_clusters
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TcpProxy_WeightedCluster)
		err := b.DecodeMessage(msg)
		m.ClusterSpecifier = &TcpProxy_WeightedClusters{msg}
		return true, err
	default:
		return false, nil
	}
}

func _TcpProxy_OneofSizer(msg proto.Message) (n int) {
	m := msg.(*TcpProxy)
	// cluster_specifier
	switch x := m.ClusterSpecifier.(type) {
	case *TcpProxy_Cluster:
		n += 1 // tag and wire
		n += proto.SizeVarint(uint64(len(x.Cluster)))
		n += len(x.Cluster)
	case *TcpProxy_WeightedClusters:
		s := proto.Size(x.WeightedClusters)
		n += 1 // tag and wire
		n += proto.SizeVarint(uint64(s))
		n += s
	case nil:
	default:
		panic(fmt.Sprintf("proto: unexpected type %T in oneof", x))
	}
	return n
}

// TCP Proxy filter configuration using V1 format, until Envoy gets the
// ability to match source/destination at the listener level (called
// :ref:`filter chain match <envoy_api_msg_listener.FilterChainMatch>`).
type TcpProxy_DeprecatedV1 struct {
	// The route table for the filter. All filter instances must have a route
	// table, even if it is empty.
	Routes               []*TcpProxy_DeprecatedV1_TCPRoute `protobuf:"bytes,1,rep,name=routes,proto3" json:"routes,omitempty"`
	XXX_NoUnkeyedLiteral struct{}                          `json:"-"`
	XXX_unrecognized     []byte                            `json:"-"`
	XXX_sizecache        int32                             `json:"-"`
}

func (m *TcpProxy_DeprecatedV1) Reset()         { *m = TcpProxy_DeprecatedV1{} }
func (m *TcpProxy_DeprecatedV1) String() string { return proto.CompactTextString(m) }
func (*TcpProxy_DeprecatedV1) ProtoMessage()    {}
func (*TcpProxy_DeprecatedV1) Descriptor() ([]byte, []int) {
	return fileDescriptor_1f6b35dbcbad27ba, []int{0, 0}
}

func (m *TcpProxy_DeprecatedV1) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TcpProxy_DeprecatedV1.Unmarshal(m, b)
}
func (m *TcpProxy_DeprecatedV1) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TcpProxy_DeprecatedV1.Marshal(b, m, deterministic)
}
func (m *TcpProxy_DeprecatedV1) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TcpProxy_DeprecatedV1.Merge(m, src)
}
func (m *TcpProxy_DeprecatedV1) XXX_Size() int {
	return xxx_messageInfo_TcpProxy_DeprecatedV1.Size(m)
}
func (m *TcpProxy_DeprecatedV1) XXX_DiscardUnknown() {
	xxx_messageInfo_TcpProxy_DeprecatedV1.DiscardUnknown(m)
}

var xxx_messageInfo_TcpProxy_DeprecatedV1 proto.InternalMessageInfo

func (m *TcpProxy_DeprecatedV1) GetRoutes() []*TcpProxy_DeprecatedV1_TCPRoute {
	if m != nil {
		return m.Routes
	}
	return nil
}

// A TCP proxy route consists of a set of optional L4 criteria and the
// name of a cluster. If a downstream connection matches all the
// specified criteria, the cluster in the route is used for the
// corresponding upstream connection. Routes are tried in the order
// specified until a match is found. If no match is found, the connection
// is closed. A route with no criteria is valid and always produces a
// match.
type TcpProxy_DeprecatedV1_TCPRoute struct {
	// The cluster to connect to when a the downstream network connection
	// matches the specified criteria.
	Cluster string `protobuf:"bytes,1,opt,name=cluster,proto3" json:"cluster,omitempty"`
	// An optional list of IP address subnets in the form
	// “ip_address/xx”. The criteria is satisfied if the destination IP
	// address of the downstream connection is contained in at least one of
	// the specified subnets. If the parameter is not specified or the list
	// is empty, the destination IP address is ignored. The destination IP
	// address of the downstream connection might be different from the
	// addresses on which the proxy is listening if the connection has been
	// redirected.
	DestinationIpList []*core.CidrRange `protobuf:"bytes,2,rep,name=destination_ip_list,json=destinationIpList,proto3" json:"destination_ip_list,omitempty"`
	// An optional string containing a comma-separated list of port numbers
	// or ranges. The criteria is satisfied if the destination port of the
	// downstream connection is contained in at least one of the specified
	// ranges. If the parameter is not specified, the destination port is
	// ignored. The destination port address of the downstream connection
	// might be different from the port on which the proxy is listening if
	// the connection has been redirected.
	DestinationPorts string `protobuf:"bytes,3,opt,name=destination_ports,json=destinationPorts,proto3" json:"destination_ports,omitempty"`
	// An optional list of IP address subnets in the form
	// “ip_address/xx”. The criteria is satisfied if the source IP address
	// of the downstream connection is contained in at least one of the
	// specified subnets. If the parameter is not specified or the list is
	// empty, the source IP address is ignored.
	SourceIpList []*core.CidrRange `protobuf:"bytes,4,rep,name=source_ip_list,json=sourceIpList,proto3" json:"source_ip_list,omitempty"`
	// An optional string containing a comma-separated list of port numbers
	// or ranges. The criteria is satisfied if the source port of the
	// downstream connection is contained in at least one of the specified
	// ranges. If the parameter is not specified, the source port is
	// ignored.
	SourcePorts          string   `protobuf:"bytes,5,opt,name=source_ports,json=sourcePorts,proto3" json:"source_ports,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) Reset()         { *m = TcpProxy_DeprecatedV1_TCPRoute{} }
func (m *TcpProxy_DeprecatedV1_TCPRoute) String() string { return proto.CompactTextString(m) }
func (*TcpProxy_DeprecatedV1_TCPRoute) ProtoMessage()    {}
func (*TcpProxy_DeprecatedV1_TCPRoute) Descriptor() ([]byte, []int) {
	return fileDescriptor_1f6b35dbcbad27ba, []int{0, 0, 0}
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.Unmarshal(m, b)
}
func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.Marshal(b, m, deterministic)
}
func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.Merge(m, src)
}
func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_Size() int {
	return xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.Size(m)
}
func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_DiscardUnknown() {
	xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.DiscardUnknown(m)
}

var xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute proto.InternalMessageInfo

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetCluster() string {
	if m != nil {
		return m.Cluster
	}
	return ""
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetDestinationIpList() []*core.CidrRange {
	if m != nil {
		return m.DestinationIpList
	}
	return nil
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetDestinationPorts() string {
	if m != nil {
		return m.DestinationPorts
	}
	return ""
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetSourceIpList() []*core.CidrRange {
	if m != nil {
		return m.SourceIpList
	}
	return nil
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetSourcePorts() string {
	if m != nil {
		return m.SourcePorts
	}
	return ""
}

// Allows for specification of multiple upstream clusters along with weights
// that indicate the percentage of traffic to be forwarded to each cluster.
// The router selects an upstream cluster based on these weights.
type TcpProxy_WeightedCluster struct {
	// Specifies one or more upstream clusters associated with the route.
	Clusters             []*TcpProxy_WeightedCluster_ClusterWeight `protobuf:"bytes,1,rep,name=clusters,proto3" json:"clusters,omitempty"`
	XXX_NoUnkeyedLiteral struct{}                                  `json:"-"`
	XXX_unrecognized     []byte                                    `json:"-"`
	XXX_sizecache        int32                                     `json:"-"`
}

func (m *TcpProxy_WeightedCluster) Reset()         { *m = TcpProxy_WeightedCluster{} }
func (m *TcpProxy_WeightedCluster) String() string { return proto.CompactTextString(m) }
func (*TcpProxy_WeightedCluster) ProtoMessage()    {}
func (*TcpProxy_WeightedCluster) Descriptor() ([]byte, []int) {
	return fileDescriptor_1f6b35dbcbad27ba, []int{0, 1}
}

func (m *TcpProxy_WeightedCluster) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TcpProxy_WeightedCluster.Unmarshal(m, b)
}
func (m *TcpProxy_WeightedCluster) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TcpProxy_WeightedCluster.Marshal(b, m, deterministic)
}
func (m *TcpProxy_WeightedCluster) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TcpProxy_WeightedCluster.Merge(m, src)
}
func (m *TcpProxy_WeightedCluster) XXX_Size() int {
	return xxx_messageInfo_TcpProxy_WeightedCluster.Size(m)
}
func (m *TcpProxy_WeightedCluster) XXX_DiscardUnknown() {
	xxx_messageInfo_TcpProxy_WeightedCluster.DiscardUnknown(m)
}

var xxx_messageInfo_TcpProxy_WeightedCluster proto.InternalMessageInfo

func (m *TcpProxy_WeightedCluster) GetClusters() []*TcpProxy_WeightedCluster_ClusterWeight {
	if m != nil {
		return m.Clusters
	}
	return nil
}

type TcpProxy_WeightedCluster_ClusterWeight struct {
	// Name of the upstream cluster.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// When a request matches the route, the choice of an upstream cluster is
	// determined by its weight. The sum of weights across all entries in the
	// clusters array determines the total weight.
	Weight               uint32   `protobuf:"varint,2,opt,name=weight,proto3" json:"weight,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *TcpProxy_WeightedCluster_ClusterWeight) Reset() {
	*m = TcpProxy_WeightedCluster_ClusterWeight{}
}
func (m *TcpProxy_WeightedCluster_ClusterWeight) String() string { return proto.CompactTextString(m) }
func (*TcpProxy_WeightedCluster_ClusterWeight) ProtoMessage()    {}
func (*TcpProxy_WeightedCluster_ClusterWeight) Descriptor() ([]byte, []int) {
	return fileDescriptor_1f6b35dbcbad27ba, []int{0, 1, 0}
}

func (m *TcpProxy_WeightedCluster_ClusterWeight) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TcpProxy_WeightedCluster_ClusterWeight.Unmarshal(m, b)
}
func (m *TcpProxy_WeightedCluster_ClusterWeight) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TcpProxy_WeightedCluster_ClusterWeight.Marshal(b, m, deterministic)
}
func (m *TcpProxy_WeightedCluster_ClusterWeight) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TcpProxy_WeightedCluster_ClusterWeight.Merge(m, src)
}
func (m *TcpProxy_WeightedCluster_ClusterWeight) XXX_Size() int {
	return xxx_messageInfo_TcpProxy_WeightedCluster_ClusterWeight.Size(m)
}
func (m *TcpProxy_WeightedCluster_ClusterWeight) XXX_DiscardUnknown() {
	xxx_messageInfo_TcpProxy_WeightedCluster_ClusterWeight.DiscardUnknown(m)
}

var xxx_messageInfo_TcpProxy_WeightedCluster_ClusterWeight proto.InternalMessageInfo

func (m *TcpProxy_WeightedCluster_ClusterWeight) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *TcpProxy_WeightedCluster_ClusterWeight) GetWeight() uint32 {
	if m != nil {
		return m.Weight
	}
	return 0
}

func init() {
	proto.RegisterType((*TcpProxy)(nil), "envoy.config.filter.network.tcp_proxy.v2.TcpProxy")
	proto.RegisterType((*TcpProxy_DeprecatedV1)(nil), "envoy.config.filter.network.tcp_proxy.v2.TcpProxy.DeprecatedV1")
	proto.RegisterType((*TcpProxy_DeprecatedV1_TCPRoute)(nil), "envoy.config.filter.network.tcp_proxy.v2.TcpProxy.DeprecatedV1.TCPRoute")
	proto.RegisterType((*TcpProxy_WeightedCluster)(nil), "envoy.config.filter.network.tcp_proxy.v2.TcpProxy.WeightedCluster")
	proto.RegisterType((*TcpProxy_WeightedCluster_ClusterWeight)(nil), "envoy.config.filter.network.tcp_proxy.v2.TcpProxy.WeightedCluster.ClusterWeight")
}

func init() {
	proto.RegisterFile("envoy/config/filter/network/tcp_proxy/v2/tcp_proxy.proto", fileDescriptor_1f6b35dbcbad27ba)
}

var fileDescriptor_1f6b35dbcbad27ba = []byte{
	// 780 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa4, 0x54, 0xdd, 0x6e, 0xdb, 0x36,
	0x14, 0x8e, 0xe4, 0x9f, 0xda, 0xb4, 0xdd, 0x35, 0x6c, 0x8b, 0x6a, 0x5a, 0xb6, 0xba, 0xdb, 0x8d,
	0x91, 0x02, 0xd2, 0xea, 0xde, 0xec, 0x6e, 0xa8, 0xdc, 0x8b, 0x64, 0x70, 0x00, 0x57, 0xc8, 0x3a,
	0x6c, 0x37, 0x02, 0x23, 0xd1, 0x0a, 0x31, 0x49, 0xe4, 0x48, 0xca, 0x76, 0xde, 0x62, 0xdb, 0xd5,
	0xb0, 0x47, 0xd8, 0x13, 0x0c, 0xbb, 0xca, 0x93, 0x6c, 0xd7, 0x79, 0x8b, 0x41, 0x14, 0x65, 0xcb,
	0xb3, 0x87, 0x04, 0xcd, 0x95, 0xc8, 0xef, 0x9c, 0xef, 0xfb, 0xa8, 0x73, 0x0e, 0x09, 0xbe, 0xc2,
	0xd9, 0x82, 0x5e, 0xb9, 0x21, 0xcd, 0xe6, 0x24, 0x76, 0xe7, 0x24, 0x91, 0x98, 0xbb, 0x19, 0x96,
	0x4b, 0xca, 0x7f, 0x74, 0x65, 0xc8, 0x02, 0xc6, 0xe9, 0xea, 0xca, 0x5d, 0x8c, 0x37, 0x1b, 0x87,
	0x71, 0x2a, 0x29, 0x1c, 0x29, 0xa6, 0x53, 0x32, 0x9d, 0x92, 0xe9, 0x68, 0xa6, 0xb3, 0x49, 0x5e,
	0x8c, 0xed, 0x2f, 0xf7, 0x79, 0xa0, 0x30, 0xc4, 0x42, 0x24, 0x34, 0x2e, 0xb4, 0xd7, 0x9b, 0x52,
	0xdb, 0x7e, 0x5e, 0x32, 0x10, 0x23, 0x45, 0x34, 0xa4, 0x1c, 0xbb, 0x28, 0x8a, 0x38, 0x16, 0x42,
	0x27, 0x1c, 0xed, 0x26, 0x5c, 0x20, 0x81, 0x75, 0xf4, 0xb3, 0x98, 0xd2, 0x38, 0xc1, 0xae, 0xda,
	0x5d, 0xe4, 0x73, 0x37, 0xca, 0x39, 0x92, 0x84, 0x66, 0xff, 0x17, 0x5f, 0x72, 0xc4, 0x18, 0xe6,
	0x95, 0xfa, 0xb3, 0x05, 0x4a, 0x48, 0x84, 0x24, 0x76, 0xab, 0x85, 0x0e, 0x3c, 0x89, 0x69, 0x4c,
	0xd5, 0xd2, 0x2d, 0x56, 0x25, 0xfa, 0xf9, 0xef, 0x3d, 0xd0, 0x39, 0x0f, 0xd9, 0xac, 0xf8, 0x5f,
	0x78, 0x0c, 0x7a, 0x42, 0x22, 0x19, 0x30, 0x8e, 0xe7, 0x64, 0x65, 0x19, 0x43, 0x63, 0xd4, 0xf5,
	0xba, 0x7f, 0xdd, 0x5c, 0x37, 0x9a, 0xdc, 0x1c, 0x1a, 0x3e, 0x28, 0xa2, 0x33, 0x15, 0x84, 0x36,
	0x78, 0x10, 0x26, 0xb9, 0x90, 0x98, 0x5b, 0x66, 0x91, 0x77, 0x72, 0xe0, 0x57, 0x00, 0xfc, 0x09,
	0x1c, 0x2e, 0x31, 0x89, 0x2f, 0x25, 0x8e, 0x02, 0x8d, 0x09, 0x0b, 0x0c, 0x8d, 0x51, 0x6f, 0xec,
	0x39, 0x77, 0x2d, 0xbd, 0x53, 0x1d, 0xcb, 0xf9, 0x4e, 0x6b, 0x4d, 0x4a, 0xa9, 0x93, 0x03, 0xff,
	0xd1, 0x72, 0x1b, 0x12, 0xd0, 0x03, 0x0f, 0x53, 0x2c, 0x51, 0x84, 0x24, 0x0a, 0x52, 0x24, 0xc3,
	0x4b, 0xab, 0xab, 0xfc, 0x3e, 0xd1, 0x7e, 0x88, 0x91, 0x42, 0xb3, 0xa8, 0xb6, 0x73, 0xa6, 0x13,
	0xfd, 0x41, 0x45, 0x39, 0x2b, 0x18, 0x70, 0x0a, 0xfa, 0x24, 0x4a, 0x70, 0x20, 0x49, 0x8a, 0x69,
	0x2e, 0xad, 0x8e, 0x52, 0xf8, 0xd8, 0x29, 0x2b, 0xee, 0x54, 0x15, 0x77, 0xde, 0xea, 0x8e, 0x78,
	0x0f, 0x7f, 0xfb, 0xe7, 0xb9, 0x51, 0x94, 0xa7, 0xf5, 0x87, 0x61, 0x1e, 0x1f, 0xf8, 0xbd, 0x82,
	0x7e, 0x5e, 0xb2, 0xe1, 0x3b, 0xf0, 0x2c, 0xa2, 0xcb, 0x4c, 0x48, 0x8e, 0x51, 0x1a, 0x6c, 0x09,
	0x37, 0x6e, 0x11, 0xf6, 0x9f, 0x6e, 0x98, 0xa7, 0x35, 0xc9, 0x33, 0xf0, 0x34, 0x67, 0xfb, 0x04,
	0x9b, 0xb7, 0x09, 0x3e, 0xae, 0x78, 0x75, 0xb9, 0x6f, 0x00, 0x28, 0x87, 0x37, 0x48, 0x68, 0x6c,
	0xb5, 0x86, 0x8d, 0x51, 0x6f, 0xfc, 0x72, 0x6f, 0x7f, 0x36, 0x33, 0xbe, 0x18, 0x3b, 0x6f, 0xd4,
	0x66, 0x4a, 0x63, 0xbf, 0x8b, 0xaa, 0x25, 0xbc, 0x04, 0x83, 0x08, 0x33, 0x8e, 0x43, 0x54, 0x34,
	0x7d, 0xf1, 0xca, 0x6a, 0xab, 0x23, 0x7d, 0xfd, 0x01, 0xed, 0x7e, 0xbb, 0xd6, 0x79, 0xff, 0xca,
	0x33, 0x2d, 0xc3, 0xef, 0x47, 0x35, 0x04, 0x7e, 0x0f, 0x9e, 0xa4, 0x68, 0x15, 0x84, 0x34, 0xcb,
	0x70, 0x28, 0x03, 0x24, 0x25, 0x4e, 0x99, 0x14, 0xd6, 0x03, 0x65, 0x78, 0xb4, 0x53, 0x83, 0x6f,
	0x4f, 0x33, 0xf9, 0x7a, 0xfc, 0x1e, 0x25, 0x39, 0xd6, 0xb3, 0x7c, 0x6c, 0x8e, 0x0c, 0x1f, 0xa6,
	0x68, 0x35, 0x29, 0x35, 0xde, 0x68, 0x09, 0xfb, 0xe7, 0x06, 0xe8, 0xd7, 0xdd, 0x61, 0x02, 0xda,
	0x9c, 0xe6, 0x12, 0x0b, 0xcb, 0x50, 0xd5, 0x39, 0xb9, 0xe7, 0xef, 0x38, 0xe7, 0x93, 0x99, 0x5f,
	0x08, 0x7a, 0x40, 0x8d, 0xcd, 0xaf, 0x86, 0xd9, 0x31, 0x7c, 0xed, 0x61, 0xff, 0x62, 0x82, 0x4e,
	0x95, 0x00, 0xbf, 0xd8, 0xdc, 0xaf, 0x9d, 0x7b, 0xb8, 0xbe, 0x68, 0x53, 0xf0, 0x38, 0xc2, 0x42,
	0x92, 0x4c, 0x75, 0x39, 0x20, 0x2c, 0x48, 0x88, 0x90, 0x96, 0xa9, 0x0e, 0x7b, 0xb4, 0x67, 0xf4,
	0x27, 0x24, 0xe2, 0x3e, 0xca, 0x62, 0xec, 0x1f, 0xd6, 0x88, 0xa7, 0x6c, 0x4a, 0x84, 0x84, 0x2f,
	0x41, 0x1d, 0x0c, 0x18, 0xe5, 0x52, 0xa8, 0x59, 0xed, 0xfa, 0x8f, 0x6a, 0x81, 0x59, 0x81, 0x17,
	0x17, 0x4e, 0xd0, 0x9c, 0x87, 0x78, 0xed, 0xda, 0xbc, 0x83, 0x6b, 0xbf, 0xe4, 0x68, 0xc3, 0x17,
	0x40, 0xef, 0xb5, 0x57, 0x4b, 0x79, 0xf5, 0x4a, 0x4c, 0xd9, 0xd8, 0x7f, 0x1b, 0xe0, 0xa3, 0xff,
	0xdc, 0x7f, 0xb8, 0x02, 0x9d, 0xf5, 0xab, 0x52, 0xf6, 0x65, 0x76, 0xff, 0x57, 0xc5, 0xd1, 0xdf,
	0x12, 0xde, 0xea, 0xcf, 0xda, 0xcd, 0x7e, 0x07, 0x06, 0x5b, 0x69, 0xf0, 0x53, 0xd0, 0xcc, 0x50,
	0x8a, 0x77, 0x5b, 0xa4, 0x60, 0xf8, 0x02, 0xb4, 0xcb, 0x97, 0x4a, 0xbd, 0x91, 0x83, 0xfa, 0xfc,
	0xe9, 0x80, 0x67, 0x83, 0x43, 0x2d, 0x1f, 0x08, 0x86, 0x43, 0x32, 0x27, 0x98, 0xc3, 0xd6, 0x9f,
	0x37, 0xd7, 0x0d, 0xc3, 0x6b, 0xfe, 0x60, 0x2e, 0xc6, 0x17, 0x6d, 0x35, 0xca, 0xaf, 0xff, 0x0d,
	0x00, 0x00, 0xff, 0xff, 0x78, 0xb9, 0x68, 0x2c, 0xef, 0x06, 0x00, 0x00,
}
